  //Bluetooth
  #include <SoftwareSerial.h>
  SoftwareSerial bluetooth(10, 11); // Pines RX, TX del módulo HC-05

  //Brazo
  #include <Wire.h>
  #include <Adafruit_PWMServoDriver.h>

  Adafruit_PWMServoDriver servoController = Adafruit_PWMServoDriver(0x40); 
  int accion;
  const uint8_t frequency = 50;    // Frecuencia PWM de 50Hz o T=20ms

  //1
  const uint16_t min1=102+150;
  const uint16_t max1=512-100;
  const uint16_t reposo1=340;
  int pos1=reposo1;
  //2
  const uint16_t min2=147;
  const uint16_t max2=512;
  const uint16_t reposo2=147;
  int pos2=reposo2;
  //3
  const uint16_t min3=122;
  const uint16_t max3=450;//antes462
  const uint16_t reposo3=122;
  int pos3=reposo3;
  //4
  const uint16_t min4=122;
  const uint16_t max4=490;//antes 502
  const uint16_t reposo4=502;
  int pos4=reposo4;
  //5
  const uint16_t min5=120+185;
  const uint16_t max5=512-180;
  int pos5=max5;

  //Carro
  const int pinVelA = 7;
  const int pinIN1 = 6;
  const int pinIN2 = 5;
  const int pinIN3 = 4;
  const int pinIN4 = 3;
  const int pinVelB = 2;
  const int velA = 150; //entre 225 y 0 130
  const int velB = 250;



void setup() {
  //Bluetooth
  Serial.begin(9600);
  bluetooth.begin(9600); 

  //Brazo
  servoController.begin();
  servoController.setPWMFreq(frequency );

  //Carro
  pinMode(pinIN1, OUTPUT);
  pinMode(pinIN2, OUTPUT);
  pinMode(pinIN3, OUTPUT);
  pinMode(pinIN4, OUTPUT);
  pinMode(pinVelA, OUTPUT);
  pinMode(pinVelB, OUTPUT);


}

void loop() {
  //Bluetooth
  if (bluetooth.available()) {
    int data = bluetooth.read();
    Serial.print(data);
    Serial.print("\n");

    //Carro
    if(data==110){
        marcha();
      }else if(data==111){
        derecha();
      }else if(data==112){
        patras();
      }else if(data==113){
        izquierda();
      }else if(data==114){
        paro();
      }else if(data==115){
        trompo();
      }

    //Brazo
    accion=data;
    if(accion==100){//avanzar
      pos2=avanza_hasta(max2/2, pos2, 12);
      pos3=avanza_hasta(max3, pos3, 13);
      pos2=avanza_hasta(max2, pos2, 12);

      pos4=retrocede_hasta(min4+150, pos4, 14);

    }else if (accion==101){//derecha
      pos1=retrocede_hasta(min1, pos1, 11);

    }else if (accion==102){//retroceder
      pos2=retrocede_hasta(min2+125, pos2, 12);
      pos3=retrocede_hasta(min3+100, pos3, 13);
      pos2=retrocede_hasta(min2, pos2, 12);
      pos3=retrocede_hasta(min3, pos3, 13);
    }else if (accion==103){//izquierda
      
    pos1=avanza_hasta(max1, pos1, 11);
    }else if (accion==104){//no se si hace falta paro
        if(pos1<reposo1){
        pos1=avanza_hasta(reposo1, pos1, 11);

      }else {
        pos1=retrocede_hasta(reposo1, pos1, 11);

      }

    }else if (accion==105){//descanso
      if(pos1<reposo1){
        pos1=avanza_hasta(reposo1, pos1, 11);

      }else {
        pos1=retrocede_hasta(reposo1, pos1, 11);

      }
      
      pos2=retrocede_hasta(min2, pos2, 12);
      pos3=retrocede_hasta(min3, pos3, 13);
      pos4=avanza_hasta(max4, pos4, 14);

    }else if (accion==106){//abre
      servoController.setPWM(15, 0, max5);

    }else if (accion==107){//cierra
      servoController.setPWM(15, 0, min5);

    }

  }
}

//Brazo
int avanza_hasta(int num_max, int num_desde, int canal){//(max ticks, pos actual)
  int pos;
  for (pos = num_desde; pos < num_max; pos++)
    {
      servoController.setPWM(canal, 0, pos);
      delay(10);
    }
  return pos;
}

int retrocede_hasta(int num_min, int num_desde, int canal){//(min ticks, pos actual)
  int pos;
  for (pos = num_desde; pos > num_min; pos--)
    {
      servoController.setPWM(canal, 0, pos);
      delay(10);
    }
  return pos;
}
//Carro
void marcha(){
    digitalWrite(pinIN1, HIGH);
    digitalWrite(pinIN2, LOW);
    analogWrite(pinVelA,velA);
    digitalWrite(pinIN3, HIGH);
    digitalWrite(pinIN4, LOW);
    analogWrite(pinVelB,velB);
}

void derecha(){
    digitalWrite(pinIN1, HIGH);
    digitalWrite(pinIN2, LOW);
    analogWrite(pinVelA,velA*0.5);
    digitalWrite(pinIN3, HIGH);
    digitalWrite(pinIN4, LOW);
    analogWrite(pinVelB,velB);
}

void  izquierda(){
    digitalWrite(pinIN1, HIGH);
    digitalWrite(pinIN2, LOW);
    analogWrite(pinVelA,velA);
    digitalWrite(pinIN3, HIGH);
    digitalWrite(pinIN4, LOW);
    analogWrite(pinVelB,velB*0.5);
}

void patras(){
    digitalWrite(pinIN1, LOW);
    digitalWrite(pinIN2, HIGH);
    analogWrite(pinVelA,velA);
    digitalWrite(pinIN3, LOW);
    digitalWrite(pinIN4, HIGH);
    analogWrite(pinVelB,velB);
}

void paro(){
    digitalWrite(pinIN1, LOW);
    digitalWrite(pinIN2, LOW);
    analogWrite(pinVelA,velA);
    digitalWrite(pinIN3, LOW);
    digitalWrite(pinIN4, LOW);
    analogWrite(pinVelB,velB);
}

void trompo(){
    digitalWrite(pinIN1, HIGH);
    digitalWrite(pinIN2, LOW);
    analogWrite(pinVelA,velA);
    digitalWrite(pinIN3, LOW);
    digitalWrite(pinIN4, HIGH);
    analogWrite(pinVelB,velB);
}