const int sensor_izq = 8; //Izquierdo 
const int sensor_der = 9;//Derecho
const int EchoPin = 13;
const int TriggerPin = 12;

int valor_der = 0;
int valor_izq = 0;

const int pinVelA = 7;//Izquierdo
const int pinIN1 = 6;
const int pinIN2 = 5;
const int pinIN3 = 4;//Derecho
const int pinIN4 = 3;
const int pinVelB = 2;


const int velA = 150; //entre 225 y 0 170
const int velB = 250;

int estado = 0;//0 recto, 1 der, 2 izq, 3 paro
int estado_memoria;

void setup() {
  Serial.begin(9600);
  pinMode(sensor_izq,INPUT);
  pinMode(sensor_der,INPUT);
  pinMode(TriggerPin, OUTPUT);
  pinMode(EchoPin, INPUT);

  pinMode(pinIN1, OUTPUT);
  pinMode(pinIN2, OUTPUT);
  pinMode(pinIN3, OUTPUT);
  pinMode(pinIN4, OUTPUT);
  pinMode(pinVelA, OUTPUT);
  pinMode(pinVelB, OUTPUT);

}

void loop() {


  valor_izq = digitalRead(sensor_izq);
  valor_der = digitalRead(sensor_der);
  int dist = ping(TriggerPin, EchoPin);

  Serial.print("Distancia: ");
  Serial.println(dist);
  Serial.print("\t");

  Serial.print("Izquierdo=");
  Serial.print(valor_izq);
  Serial.print("\t Derecho=");
  Serial.print(valor_der);
  Serial.print("\t");
  delay(100);

  //Importante saber, que el TOCHO devuelve B->0  N->1
  //                         SIMPLE devuelve B->1  N->0
  //  TOCHO izquierda fuera SIMPLE derecha dentro

  //IMPORTANTE SE HA DE COLOCAR EN ESTADO 0 osea el derecho sobre la linea y el izquierdo no 

  //maquina de estados 0 recto, 1 der, 2 izq, 3 paro
  //La maquina de estado hace los siguiente: 1º de todo comprueba(independientemente del estado en que se encuentre) si la distancia es menor a 10 cm
  //si lo es, guarda en la memoria el estado en el que se encontraba y activa el estado 3. Si no lo es realiza la maquina de estados sin considerar el 
  //paro. 
  //

  if(estado == 0){//00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
    if(dist<10){
      estado_memoria=estado;
      estado=3;
    }else{//aquí maquina de estado normal
      if(valor_izq==0 && valor_der==0 ){
        estado=0;
      }else if(valor_izq==1 && valor_der==0 ){
        estado=0;
      }else if(valor_izq==0 && valor_der==1 ){
        estado=1;
      }else if(valor_izq==1 && valor_der==1 ){
        estado=2;
      }

    }

  }else if(estado == 1){//11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
     if(dist<10){
      estado_memoria=estado;
      estado=3;
    }else{//aquí maquina de estado normal
      if(valor_izq==0 && valor_der==1 ){
        estado=1;
      }else if(valor_izq==0 && valor_der==0 ){
        estado=0;
      }else if(valor_izq==1 && valor_der==0 ){
        estado=0;
      }

    }
 
  }else if(estado == 2){//2222222222222222222222222222222222222222222222222222222222222222222222222222222222222222
    if(dist<10){
      estado_memoria=estado;
      estado=3;
    }else{//aquí maquina de estado normal
       if(valor_izq==1 && valor_der==1 ){
        estado=2;
      }else if(valor_izq==0 && valor_der==1 ){
        estado=2;
      }else if(valor_izq==0 && valor_der==0 ){
        estado=0;
      }else if(valor_izq==1 && valor_der==0 ){
        estado=0;
      }

      
    }

  }else if(estado == 3){
    if(dist>10){
      if(estado_memoria == 0){
        estado=estado_memoria;
      }else if(estado_memoria == 1){
        estado=estado_memoria;
      }else if(estado_memoria == 2){
        estado=estado_memoria;
      }

    }
  }



  //implantación de estado 0 recto, 1 der, 2 izq, 3 paro
  if(estado == 0){
    marcha();
  }else if(estado == 1){
    der();
  }else if(estado == 2){
    izq();
  }else{
    paro();
  } 
  Serial.print("Estado: ");
  Serial.print(estado);
  Serial.print("\t");

}
int ping(int TriggerPin, int EchoPin) {
  long duration, distanceCm;
  
  digitalWrite(TriggerPin, LOW);  //para generar un pulso limpio ponemos a LOW 4us
  delayMicroseconds(4);
  digitalWrite(TriggerPin, HIGH);  //generamos Trigger (disparo) de 10us
  delayMicroseconds(10);
  digitalWrite(TriggerPin, LOW);
  
  duration = pulseIn(EchoPin, HIGH);  //medimos el tiempo entre pulsos, en microsegundos
  
  distanceCm = duration * 10 / 292/ 2;   //convertimos a distancia, en cm
  return distanceCm;
}

void marcha(void){
    digitalWrite(pinIN1, HIGH);
    digitalWrite(pinIN2, LOW);
    analogWrite(pinVelA,velA);
    digitalWrite(pinIN3, HIGH);
    digitalWrite(pinIN4, LOW);
    analogWrite(pinVelB,velB);
}

void izq(void){
    digitalWrite(pinIN1, HIGH);
    digitalWrite(pinIN2, LOW);
    analogWrite(pinVelA,velA*1);
    digitalWrite(pinIN3, HIGH);
    digitalWrite(pinIN4, LOW);
    analogWrite(pinVelB,velB*0.25);
}

void der(void){
    digitalWrite(pinIN1, HIGH);
    digitalWrite(pinIN2, LOW);
    analogWrite(pinVelA,velA*0.25);
    digitalWrite(pinIN3, HIGH);
    digitalWrite(pinIN4, LOW);
    analogWrite(pinVelB,velB*0.75);
}

void paro(void){
    digitalWrite(pinIN1, LOW);
    digitalWrite(pinIN2, LOW);
    analogWrite(pinVelA,velA);
    digitalWrite(pinIN3, LOW);
    digitalWrite(pinIN4, LOW);
    analogWrite(pinVelB,velB);
}


